SystemOrganization addCategory: #HW5!

TestCase subclass: #WordStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HW5'!

!WordStreamTest methodsFor: 'as yet unclassified' stamp: 'MattMomont 6/21/2014 12:50'!
testEdgeCases
	| stream edgeCases |
	edgeCases := #('hello world' ' hello world' 'hello world ' 'hello  world').
	
	edgeCases do: [ :each |  
		stream := WordStream string: each.
		self assert: stream next = 'hello'.
		self assert: stream next = 'world'.
		self assert: stream size = 2.
	].! !

!WordStreamTest methodsFor: 'as yet unclassified' stamp: 'MattMomont 6/21/2014 13:09'!
testEmptyCase
	| stream |
	stream := WordStream string: ''.
	self assert: stream atEnd.
	self assert: stream size = 0.
	
	stream := WordStream string: '!!-)('.
	self assert: stream atEnd.
	self assert: stream size = 0.! !

!WordStreamTest methodsFor: 'as yet unclassified' stamp: 'MattMomont 6/21/2014 13:03'!
testNumberOfWordsInFile
	| file filename stream |
	filename := 'number-of-words.tst'.
	(StandardFileStream forceNewFileNamed: filename)
		nextPutAll: 'My name is!!not Matt''s';
		close.
	file := StandardFileStream readOnlyFileNamed: filename.
	stream := WordStream string: (file contentsOfEntireFile).
	self assert: (stream size = 6).! !

Object subclass: #WordStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HW5'!

!WordStream commentStamp: '<historical>' prior: 0!
A WordStream converts a string into a stream of words.
!

!WordStream class methodsFor: 'as yet unclassified' stamp: 'MattMomont 6/21/2014 12:44'!
string: aString 
	"^(aString subStrings: ' ') readStream."
	^(aString findTokens: (#($. $, $!! $? $; $: $" $' $- $( $) $`), Character separators)) readStream.! !
